-------------------------------------------------------------------------------------------------
-- BallyHVG.lua 1.0
-- Written by Richard C Degler, August 2009
--
-- Annotates the Bally Astrocade Home Video Game 8K ROM ReSTart $38's
-------------------------------------------------------------------------------------------------


--------------------
-- RST 0, or RST 0, RST $00
--------------------

function RST0pre()

-- Add a comment on the RST 0
	d_AddComment(" System ReSeT")
	return
end


--------------------
-- RSTs 1 to 6,
-- RSTs 8 to 48 (step 8),
-- or RSTs $08 to $30

-- Add a comment on the RST 1 to 6
--------------------

function RST8pre()

	d_AddComment(" User ReStarT \#1 of 6")
	return
end

----------

function RST10pre()

	d_AddComment(" User ReStarT \#2 of 6")
	return
end

----------

function RST18pre()

	d_AddComment(" User ReStarT \#3 of 6")
	return
end

----------

function RST20pre()

	d_AddComment(" User ReStarT \#4 of 6")
	return
end

----------

function RST28pre()

	d_AddComment(" User ReStarT \#5 of 6")
	return
end

----------

function RST30pre()

	d_AddComment(" User ReStarT \#6 of 6")
	return
end

----------



--------------------
-- RST 7, bin RST 56, or hex RST $38
comment = [[ UPI Routine Names as EVEN numbers, as usual.
	Missing Routine Number + 1 flags that suck needed.

	Argument descriptions cause single or double suck.
]]
--------------------

UPItab={

-- USER PROGRAM Interface:
	[0] =	{name="INTPC",comment="INTerPret with Context create"},
		-- none

	[2] =	{name="XINTC",comment="eXit INTerpreter with Context"},
		-- none

	[4] =	{name="RCALL",comment="Real CALL asm language subroutine",
		HL="Real Address"},

	[6] =	{name="MCALL",comment="Macro CALL interpreter subroutine",
		HL="Macro Address"},

	[8] =	{name="MRET",comment="Macro RETurn from interpreter subroutine"},
		-- none

	[10] =	{name="MJUMP",comment="Macro JUMP to interpreter subroutine",
		HL="Macro Address"},

	[12] =	{name="SUCK",comment="SUCK inline args into context block",
		A="Mask"},

-- SCHEDULER Routines:
	[14] =	{name="ACTINT",comment="ACTivate sub timer INTerrupts"},
		-- none

	[16] =	{name="DECCTS",comment="DECrement CT'S under mask",
		C="Counters"},

-- MUSIC and SOUNDS:
	[18] =	{name="BMUSIC",comment="Begin playing MUSIC",
		IX="Music Stack",A="Voices",HL="Score Address"},

	[20] =	{name="EMUSIC",comment="End playing MUSIC"},
		-- none

-- SCREEN HANDLER Routines:
	[22] =	{name="SETOUT",comment="SET some OUTput ports",
		D="VERBL*2",B="HORCB/4",A="INMOD"},

	[24] =	{name="COLSET",comment="COLors SET",
		HL="Table Address"},

	[26] =	{name="FILL",comment="FILL memory with data",
		DE="Memory Address",BC="Byte Count",A="Data"},

	[28] =	{name="RECTAN",comment="paint a RECTANgle",
		E="X",D="Y",C="Width",B="Height",A="Color"},

	[30] =	{name="VWRITR",comment="Vector WRITe Relative",
		IX="Vector Block",HL="Pattern Address"},

	[32] =	{name="WRITR",comment="WRITe RELATIVE",
		E="X",D="Y",A="Magic",HL="Pattern Address"},

	[34] =	{name="WRITP",comment="WRITe with Pattern size lookup",
		E="X",D="Y",A="Magic",HL="Pattern Address"},

	[36] =	{name="WRIT",comment="WRITe with sizes provided",
		E="X",D="Y",C="Bytes",B="Rows",A="Magic",HL="Pattern Address"},

	[38] =	{name="WRITA",comment="WRITe Absolute",
		DE="Screen Address",C="Bytes",B="Rows",A="Magic",HL="Pattern Address"},

	[40] =	{name="VBLANK",comment="Vector BLANK area",
		IX="Vector Block",E="Bytes",D="Rows"},

	[42] =	{name="BLANK",comment="BLANK area",
		E="Width",D="Height",B="Data",HL="Screen Address"},

	[44] =	{name="SAVE",comment="SAVE area",
		DE="Memory Address",C="Bytes",B="Rows",HL="Screen Address"},

	[46] =	{name="RESTOR",comment="RESTORe area",
		DE="Memory Address",HL="Screen Address"},

	[48] =	{name="SCROLL",comment="SCROLL area of screen",
		DE="Line Increment",C="Bytes",B="Rows",HL="Screen Address"},
--
	[50] =	{name="CHRDIS",comment="CHaRacter DISplay",
		E="X",D="Y",C="Options",A="Character"},

	[52] =	{name="STRDIS",comment="STRing DISplay",
		E="X",D="Y",C="Options",HL="String Address"},

	[54] =	{name="DISNUM",comment="DISplay NUMber",
		E="X",D="Y",C="Options",B="Extended",HL="Number Address"},
--
	[56] =	{name="RELABS",comment="RELative to ABSolute conversion",
		A="Magic"},

	[58] =	{name="RELAB1",comment="RELative to non-magic ABSolute",
		A="Magic"},

	[60] =	{name="VECTC",comment="VECTor move single Coordinate",
		IX="Coordinate Block",C="Timebase",HL="Limit Table"},

	[62] =	{name="VECT",comment="VECTor move coordinate pair",
		IX="Vector Block",HL="Limit Table"},

-- HUMAN INTERFACE Routines:
	[64] =	{name="KCTASC",comment="Key Code in B To ASCii"},
		-- unsucked

	[66] =	{name="SENTRY",comment="SENse TRansition",
		DE="Keymask Address"},

	[68] =	{name="DOIT",comment="DOIT table, branch to translation handler",
		HL="Table Address"},

	[70] =	{name="DOITB",comment="DOIT table, use B instead of A",
		HL="Table Address"},

	[72] =	{name="PIZBRK",comment="take a PIZza BReaK"},
		-- none

	[74] =	{name="MENU",comment="display a MENU",
		DE="Title Address",HL="Menu List"},

	[76] =	{name="GETPAR",comment="GET game PARameter from user",
		BC="Prompt Address",A="Digits",HL="Parameter Address"},

	[78] =	{name="GETNUM",comment="GET NUMber from user",
		E="X",D="Y",C="Options",B="Extended",HL="Number Address"},

	[80] =	{name="PAWS",comment="PAUSE",
		B="Interrupts"},

	[82] =	{name="DISTIM",comment="DISplay TIMe",
		E="X",D="Y",C="Options"},

	[84] =	{name="INCSCR",comment="INCrement SCoRe",
		HL="Score Address"},

-- MATH Routines:
	[86] =	{name="INDEXN",comment="INDEX Nibble by C",
		HL="Base Address"},

	[88] =	{name="STOREN",comment="STORE Nibble in A by C",
		HL="Base Address"},

	[90] =	{name="INDEXW",comment="INDEX Word by A",
		HL="Base Address"},

	[92] =	{name="INDEXB",comment="INDEX Byte by A",
		HL="Base Address"},

	[94] =	{name="MOVE",comment="MOVE block transfer",
		DE="Destination Address",BC="Byte Count",HL="Source Address"},

-- ?? these were NOT documented in the DNA manual
	[96] =	{name="SHIFTU",comment="SHIFT Up digit in A",
		B="Amount",HL="Number Address"},

	[98] =	{name="BCDADD",comment="BCD ADDition",
		DE="Augend Address",B="Digits/2",HL="Addend Address"},

	[100] =	{name="BCDSUB",comment="BCD SUBtraction",
		DE="Minuend Address",B="Digits/2",HL="Subtrahend Address"},

	[102] =	{name="BCDMUL",comment="BCD MULtiplication",
		DE="Multiplicand Address",B="Digits/2",HL="Multiplier Address"},

	[104] =	{name="BCDDIV",comment="BCD DIVision",
		DE="Dividend Address",B="Digits/2",HL="Divisor Address"},

	[106] =	{name="BCDCHS",comment="BCD CHange Sign",
		B="Digits/2",HL="Number Address"},

	[108] =	{name="BCDNEG",comment="BCD NEGate to decimal",
		DE="Number Address",B="Digits/2"},

	[110] =	{name="DADD",comment="Decimal ADDition",
		DE="Augend Address",B="Digits/2",HL="Addend Address"},

	[112] =	{name="DSMG",comment="Decimal convert to Sign MaGnitude",
		DE="Tens Compliment",B="Digits/2"},

	[114] =	{name="DABS",comment="Decimal ABSolute value",
		DE="Number Address",B="Digits/2"},

	[116] =	{name="NEGT",comment="decimal NEGaTe",
		B="Digits/2",HL="Number Address"},

	[118] =	{name="RANGED",comment="RANGED random number",
		A="Cutoff"},

	[120] =	{name="QUIT",comment="QUIT cassette execution"},
		-- none

	[122] =	{name="SETB",comment="SET Byte",
		A="Data",HL="Memory Address"},

	[124] =	{name="SETW",comment="SET Word",
		DE="Data Word",HL="Memory Address"},

	[126] =	{name="MSKTD",comment="MaSK joystick in B To Deltas",
		DE="X Delta",C="Flop",HL="Y Delta"},

-- User MACRO routines - UGLY, but only way to do modulo-2 sucks!
	[128] = {},[130]={},[132]={},[134]={},[136]={},[138]={},[140]={},[142]={},
	[144] =	{},[146]={},[148]={},[150]={},[152]={},[154]={},[156]={},[158]={},
	[160] =	{},[162]={},[164]={},[166]={},[168]={},[170]={},[172]={},[174]={},
	[176] =	{},[178]={},[180]={},[182]={},[184]={},[186]={},[188]={},[190]={},
	[192] =	{},[194]={},[196]={},[198]={},[200]={},[202]={},[204]={},[206]={},
	[208] =	{},[210]={},[212]={},[214]={},[216]={},[218]={},[220]={},[222]={},
	[224] =	{},[226]={},[228]={},[230]={},[232]={},[234]={},[236]={},[238]={},
	[240] =	{},[242]={},[244]={},[246]={},[248]={},[250]={},[252]={},[254]={}
	}

----------

function RST38pre()

	local b,c,suck,INTPCC

	INTPCC = "FALSE"

-- eat the $FF
	b = d_GetByte()

-- do while INTPCC == "TRUE"
	repeat

-- read next byte
		b = d_GetByte()

		if UPItab[b] then
			suck = 0
		else
			b = b - 1
			suck = 1
		end

		if INTPCC == "FALSE" then
			if suck == 0 then
				d_AddToDisTab("SYSTEM")
			else
				d_AddToDisTab("SYSSUK")
			end
		else
			if suck == 0 then
				d_AddToDisTab("DONT")
			else
				d_AddToDisTab("DO")
			end
		end

-- loop control
		if b == 0 then
			INTPCC = "TRUE"
		end

		if b == 2 then
			INTPCC = "FALSE"
		end

-- lookup UPI name
		c = UPItab[b].name

		if c then
			c = format("%s", c)
		else
			c = format("User MACRO routine \$%02x", b + suck)
		end

		d_AddToDis(c)

-- lookup UPI comment
		c = UPItab[b].comment

		if c then
			c = format(" UPI %s", c)
		else
			c = format("<-- rename \"User MACRO routine %d\" and adjust", b + suck)
		end

		d_AddComment(c)

		d_FlushLine()

-- lookup any arguments
		if suck == 1 then
			c = UPItab[b].IX
	 		if c then
				fetchWord(c)
			end

			c = UPItab[b].DE
	 		if c then
				fetchWord(c)
			else
				c = UPItab[b].E
	 			if c then
					fetchByte(c)
				end

				c = UPItab[b].D
	 			if c then
					fetchByte(c)
				end
			end

			c = UPItab[b].BC
	 		if c then
				fetchWord(c)
			else
				c = UPItab[b].C
	 			if c then
					fetchByte(c)
				end

				c = UPItab[b].B
	 			if c then
					fetchByte(c)
				end
			end

			c = UPItab[b].A
	 		if c then
				fetchByte(c)
			end

			c = UPItab[b].HL
	 		if c then
				fetchWord(c)
			else
				c = UPItab[b].L
	 			if c then
					fetchByte(c)
				end

				c = UPItab[b].H
	 			if c then
					fetchByte(c)
				end
			end
		end


-- finish with a blank line
		d_AddToDis("\;")
		d_FlushLine()

	until INTPCC == "FALSE"

	return
end


function fetchByte(c)

	local data

	data = d_GetByte()
	d_DB(data)
	c = format(" ... %s = %d", c, data)
	d_AddComment(c)
	d_FlushLine()

	return
end

function fetchWord(c)

	local data

	d_AddToDisTab("DW")
	data = d_GetByte()
	data = data + 256 * d_GetByte()
	d_AddToDis(format("\$%04x", data))

	c = format(" ... %s = %d", c, data)
	d_AddComment(c)
	d_FlushLine()

	return
end


---------------------------------------------------
-- Script initialisation and registration goes here
---------------------------------------------------

d_PreTrap (199, RST0pre)

d_PreTrap (207, RST8pre)
d_PreTrap (215, RST10pre)
d_PreTrap (223, RST18pre)
d_PreTrap (231, RST20pre)
d_PreTrap (239, RST28pre)
d_PreTrap (247, RST30pre)

d_PreTrap (hex"ff", RST38pre)


-- Finished
